//+------------------------------------------------------------------+
//|                                                      Delayer.mq4 |
//|                                 Copyright  2012 by Mike Zhitnev |
//|                                           http://Forex-Robots.ru |
//|                  : admin@forex-robots.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012 by Mike Zhitnev"
#property link      "http://Forex-Robots.ru"
#include <stdlib.mqh>
#include <WinUser32.mqh>

extern int    FastPeriod= 20;       //   MA
extern int    SlowPeriod= 37;       //   MA 
extern double Lots =      0.1;      //  
extern int    TakeProfit =100;      //                                    
extern int    StopLoss =  20;       //  
extern int    Slippage =  2;        //     
extern int    TrallSize = 10;       // .  0,  .
extern int    Delta =     20;       // 
extern int    Magic     = 13238;    //  

bool Signal;
double Price;

datetime LastTime;

//+------------------------------------------------------------------+
//|     TYPE,         |
//+------------------------------------------------------------------+
int OrderExists(int Type)
  {    
    if (OrdersTotal()==0) return(-1);
    for (int i=0; i<OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderType()==Type && OrderMagicNumber()==Magic) return(OrderTicket());
    return(-1);  
  }  

//+------------------------------------------------------------------+
//|     BUY                                  |
//+------------------------------------------------------------------+
int CloseBuyOrders()
  {
    while (OrderExists(OP_BUY)>0)
    {
      RefreshRates();     
      OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage, Blue);
      if (PrintError(215)>0) Sleep(1000);              
    }      
  }

//+------------------------------------------------------------------+
//|     SELL                                 |
//+------------------------------------------------------------------+
int CloseSellOrders()
  {
    while (OrderExists(OP_SELL)>0)
    {
      RefreshRates();     
      OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage, Red);
      if (PrintError(242)>0) Sleep(1000);              
    }      
  }

//+------------------------------------------------------------------+
//|       PIPS,                 |
//+------------------------------------------------------------------+
void Tralling(int Pips)
  {
    int n=OrdersTotal();    
    for(int i=0;i<n;i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==Magic && OrderSymbol()==Symbol())
      {  
        double SL = OrderStopLoss();  
        RefreshRates();
        if (OrderType()==OP_BUY && Ask>SL+(StopLoss+Pips)*Point) 
          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL+Pips*Point,Digits), OrderTakeProfit(), 0, Yellow);
        if (OrderType()==OP_SELL && Bid<SL-(StopLoss+Pips)*Point) 
          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL-Pips*Point,Digits),OrderTakeProfit(), 0, Yellow);        
      }
  }

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Signal = -1;
   return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
int BuyMarket() 
  {
     CloseSellOrders();
     CloseBuyOrders();
     RefreshRates();    
     double op = NormalizeDouble(Ask,Digits);       
     double tp = NormalizeDouble(Ask + TakeProfit*Point,Digits);
     if (TakeProfit==0) tp=0;
     double sl = NormalizeDouble(Ask - StopLoss*Point,Digits);   
     if (StopLoss==0) sl=0;     
     Print("        ASK=" + DoubleToStr(Ask,Digits));                                 
     OrderSend(Symbol(),OP_BUY, Lots, op, Slippage, sl, tp, "", Magic, 0 ,Blue);        
     if (PrintError(115)>0)
        Print("   BUY");  
     else       
       Signal = -1;    
  }

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
int SellMarket() 
  {
     CloseBuyOrders();
     CloseSellOrders();
     RefreshRates();
     double op = NormalizeDouble(Bid,Digits);       
     double tp = NormalizeDouble(Bid - TakeProfit*Point,Digits);
     if (TakeProfit==0) tp=0;
     double sl = NormalizeDouble(Bid + StopLoss*Point,Digits);                     
     if (StopLoss==0) sl=0;
     Print("        BID=" + DoubleToStr(Bid,Digits));  
     OrderSend(Symbol(), OP_SELL, Lots, op, Slippage, sl, tp, "", Magic, 0 ,Red);                                    
     if (PrintError(136)>0) 
       Print("   SELL"); 
     else       
       Signal = -1;    
  }

//+------------------------------------------------------------------+
//|    ,  Part -              |
//+------------------------------------------------------------------+
int PrintError(int Part)
  {
    int error = GetLastError();
    if (error!=0) 
    {
      Print("Part " + Part + "; Error " + error + ": " + ErrorDescription(error));
      PlaySound("alert.wav");
    }  
    return(error);
  }  

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if (TrallSize>0 && StopLoss!=0) Tralling(TrallSize);
  
   //double Spread = MarketInfo(Symbol(),MODE_SPREAD); 
   
   if (Signal==OP_BUY && Bid>=Price+(Delta)*Point) BuyMarket();  
   if (Signal==OP_SELL && Bid<=Price-(Delta)*Point) SellMarket();     
   
   double CO = MathAbs(Bid-Price)/Point;
   if (Signal!=-1) 
     Comment("  Bid   : " + DoubleToStr(Price,Digits) + "\n" +
             " : " + DoubleToStr(CO, 0) + ", : " + Delta);
   else
     Comment("  ...");        
   
   // ,  ,      
   if (LastTime==Time[0]) return(0);
   LastTime=Time[0];      
         
   double EMA_Fast0 = iMA(NULL, 0, FastPeriod, 0, MODE_EMA, PRICE_CLOSE, 1);
   double EMA_Slow0 = iMA(NULL, 0, SlowPeriod, 0, MODE_EMA, PRICE_CLOSE, 1);

   double EMA_Fast1 = iMA(NULL, 0, FastPeriod, 0, MODE_EMA, PRICE_CLOSE, 2);
   double EMA_Slow1 = iMA(NULL, 0, SlowPeriod, 0, MODE_EMA, PRICE_CLOSE, 2);
   
      
   //    
   if (EMA_Fast0>EMA_Slow0 && EMA_Fast1<EMA_Slow1)
   {    
       Signal = OP_SELL;       
       Price = Close[1];    
       Print("   ,  = " + DoubleToStr(Price, Digits));
       PlaySound("alert.wav");         
   } 
   
   //    
   if (EMA_Fast0<EMA_Slow0 && EMA_Fast1>EMA_Slow1)
   {     
       Signal = OP_BUY;            
       Price = Close[1];
       Print("   ,  = " + DoubleToStr(Price, Digits));
       PlaySound("alert.wav");                
   } 
      
      
   return(0);
  }
//+------------------------------------------------------------------+